package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.utils.PrintStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ConvertVideo {
  private static String inputPath = "";
  
  private static String outputPath = "";
  
  private static String ffmpegPath = "";
  
  public static void main(String[] args) throws IOException {
    getPath();
    if (!checkfile(inputPath)) {
      System.out.println(String.valueOf(inputPath) + " is not file");
      return;
    } 
    if (process())
      System.out.println("ok"); 
  }
  
  public static void getPath() {
    File diretory = new File("");
    try {
      String currPath = diretory.getAbsolutePath();
      inputPath = "E:\\1.MP4";
      outputPath = "E:\\vod\\";
      ffmpegPath = "E:\\ConvertVideo\\ffmpeg1\\";
      System.out.println(currPath);
    } catch (Exception e) {
      System.out.println("getPath出错");
    } 
  }
  
  public static boolean process() {
    int type = checkContentType();
    boolean status = false;
    System.out.println("直接转成mp4格式");
    status = processMp4(inputPath);
    return status;
  }
  
  private static int checkContentType() {
    String type = inputPath.substring(inputPath.lastIndexOf(".") + 1, inputPath.length())
      .toLowerCase();
    if (type.equals("avi"))
      return 0; 
    if (type.equals("mpg"))
      return 0; 
    if (type.equals("wmv"))
      return 0; 
    if (type.equals("3gp"))
      return 0; 
    if (type.equals("mov"))
      return 0; 
    if (type.equals("mp4"))
      return 0; 
    if (type.equals("asf"))
      return 0; 
    if (type.equals("asx"))
      return 0; 
    if (type.equals("flv"))
      return 0; 
    if (type.equals("wmv9"))
      return 1; 
    if (type.equals("rm"))
      return 1; 
    if (type.equals("rmvb"))
      return 1; 
    return 9;
  }
  
  private static boolean checkfile(String path) {
    File file = new File(path);
    if (!file.isFile())
      return false; 
    return true;
  }
  
  private static String processAVI(int type) {
    List<String> commend = new ArrayList<>();
    commend.add(String.valueOf(ffmpegPath) + "mencoder");
    commend.add(inputPath);
    commend.add("-oac");
    commend.add("lavc");
    commend.add("-lavcopts");
    commend.add("acodec=mp3:abitrate=64");
    commend.add("-ovc");
    commend.add("xvid");
    commend.add("-xvidencopts");
    commend.add("bitrate=600");
    commend.add("-of");
    commend.add("mp4");
    commend.add("-o");
    commend.add(String.valueOf(outputPath) + "a.AVI");
    try {
      ProcessBuilder builder = new ProcessBuilder(new String[0]);
      Process process = builder.command(commend).redirectErrorStream(true).start();
      process.waitFor();
      return String.valueOf(outputPath) + "a.AVI";
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
  }
  
  private static boolean processFlv(String oldfilepath) {
    if (!checkfile(inputPath)) {
      System.out.println(String.valueOf(oldfilepath) + " is not file");
      return false;
    } 
    List<String> command = new ArrayList<>();
    command.add(String.valueOf(ffmpegPath) + "ffmpeg");
    command.add("-i");
    command.add(oldfilepath);
    command.add("-ab");
    command.add("56");
    command.add("-ar");
    command.add("22050");
    command.add("-qscale");
    command.add("8");
    command.add("-r");
    command.add("15");
    command.add("-s");
    command.add("600x500");
    command.add(String.valueOf(outputPath) + "a.flv");
    try {
      Process videoProcess = (new ProcessBuilder(command)).redirectErrorStream(true).start();
      (new PrintStream(videoProcess.getErrorStream())).start();
      (new PrintStream(videoProcess.getInputStream())).start();
      videoProcess.waitFor();
      return true;
    } catch (Exception e) {
      e.printStackTrace();
      return false;
    } 
  }
  
  private static boolean processMp4(String oldfilepath) {
    if (!checkfile(inputPath)) {
      System.out.println(String.valueOf(oldfilepath) + " is not file");
      return false;
    } 
    List<String> command = new ArrayList<>();
    command.add(String.valueOf(ffmpegPath) + "ffmpeg");
    command.add("-i");
    command.add(oldfilepath);
    command.add("-c:v");
    command.add("libx264");
    command.add("-mbd");
    command.add("0");
    command.add("-c:a");
    command.add("aac");
    command.add("-strict");
    command.add("-2");
    command.add("-pix_fmt");
    command.add("yuv420p");
    command.add("-movflags");
    command.add("faststart");
    command.add(String.valueOf(outputPath) + "a.mp4");
    try {
      Process videoProcess = (new ProcessBuilder(command)).redirectErrorStream(true).start();
      (new PrintStream(videoProcess.getErrorStream())).start();
      (new PrintStream(videoProcess.getInputStream())).start();
      videoProcess.waitFor();
      return true;
    } catch (Exception e) {
      e.printStackTrace();
      return false;
    } 
  }
}
